<?php
/*
==========================================
 PHP-NUKE: Guild Application module
Version 2.2.1
==========================================
 Copyright (c) 2007
  by Nathan Burke
  based on work by:
    Arioch - http://www.black-blades.org
	
Edited on 11/19/08 by blakbyrd to include Death Knight and Inscription profession

 This program is free software. You can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation
 
==========================================
*/


$module_name = basename(dirname(__FILE__));
define('NO_EDITOR', TRUE);  //Supress WYSIWYG editor - comment out if not applicable

include("header.php");
require_once("variables.php");

OpenTable();
initialize($Variables, $KeyData, $TextBoxData);
gimmeCharData($CharData, $Variables['numalts']['value']);
gimmeData($UserData, "userinfo");

if(!$_POST)  //if there's no post data, there's nothing we can do so return to form
{
	include("request_form.php");
	requestform();
	CloseTable();
	include("footer.php");
	exit;
}

//We can rebuild him, we have the technoligy
//Turn the postdata into a properly formatted array
$tempArray1 = array_values($_POST);
$tempArray2 = array_keys($_POST);
for($i = 0; $i < count($_POST); $i++)
{
	$field = explode("_", $tempArray2[$i]);
	$PostData[$i] = array('name' => $field[0], $field[1] => $tempArray1[$i]);
}

foreach($PostData as $key => $row)
{
	switch(strtoupper($row['name'][0]))
	{
		case 'M':
			fillCharArray($PostData[$key]['name'], 0, $row['text'], $CharData);
			break;
		case 'A':
			fillCharArray($PostData[$key]['name'], $row['name'][3] + 1, $row['text'], $CharData);
			break;
		case 'U':
			fillArray($PostData[$key]['name'], $row['text'], $UserData);
			break;
		case 'K':
			fillKeyArray($PostData[$key]['name'], $row['text'], $KeyData);
			break;
		case 'T':
			fillArray($PostData[$key]['name'], $row['text'], $TextBoxData);
	}
}

// Are all required fields entered?
$missing = 0;

//character fields
$i = 0;
foreach($CharData as $index => $Char)
{
	foreach($Char as $key => $field)
	{
		if($field['name'] == "resist") continue;
		if($field['name'] == "name" && $field['text'] != "")
			$i = 2;
		if($field['text'] == "" && $field['required'] == 1 && $field['name'] != "" && ($i == 0 || $i == 2))
		{
			$CharData[$index][$key]['missing'] = 1;
			$missing++;
		}
	}
	if($Char['build']['required'] == 1 && ($i == 0 || $i == 2))
	{
		if($Char['build']['text'] == "")
		{
			$CharData[$index]['build']['missing'] = 1;
			$missing++;
		}
		if($Char['build0']['text'] == "")
		{
			$CharData[$index]['build0']['missing'] = 1;
			$missing++;
		}
		if($Char['build1']['text'] == "")
		{
			$CharData[$index]['build1']['missing'] = 1;
			$missing++;
		}
		if($Char['build2']['text'] == "")
		{
			$CharData[$index]['build2']['missing'] = 1;
			$missing++;
		}
	}
	if($Char['resist']['required'] == 1 && ($i == 0 || $i == 2))
		foreach($Char['resistances'] as $key => $resist)
			if($resist['text'] == "")
			{
				$CharData[$index]['resistances'][$key]['missing'] = 1;
				$missing++;
			}
	$i = 1;
}

//TextBoxes
foreach($TextBoxData as $key => $text)
{
	if($text['required'] == 1 && $text['text'] == "")
	{
		$TextBoxData[$key]['missing'] = 1;
		$missing++;
	}
}

//Keys
foreach($KeyData as $key0 => $type)
	foreach($type['keys'] as $key1 => $gamekey)
	{
		if($gamekey['required'] == 1 && $KeyData[$key0]['keys'][$key1]['text'] == "")
		{
			$KeyData[$key0]['keys'][$key1]['missing'] = 1;
			$missing++;
		}
	}

//User info
foreach($UserData as $key => $user)
	if($user['required'] == 1 && $user['text'] == "")
	{
		$UserData[$key]['missing'] = 1;
		$missing++;
	}

/*
//Refferals
if($Variables['referral']['required'] == 1 && $Variables['referral']['text'] == "")
{
	$Variables['referral']['missing'] = true;
	$missing++;
}
*/
// If something is missing (or several things are missing) reload form
if ($missing > 0)
{
	echo "<font color=\"#FF0000\"><center><h1><strong>Please fill in the missing";
	if ($missing == 1)
		echo " field";
	else 
		echo " fields";
	echo " and re-submit</strong></center></h1></font>";
	include("request_form.php");
	requestform($UserData, $CharData, $KeyData, $TextBoxData, $Variables, true);
	CloseTable();
	include("footer.php");
	exit;
}

// Check the email address for validity
include("validateEmailFormat.php");  //This is the file that actually does the checking
$isValid = validateEmailFormat($UserData['email']['text']); //Make the call to the function loaded from the other file
if(!$isValid && $UserData['email']['required'] == 1) 
{
  echo "<center><font color=\"#FF0000\"><strong>Your Email Address does not appear to be in the correct format!<br>
	  Please check and resubmit form</strong></font></center><br><br>";
  include("request_form.php");
  requestform($UserData, $CharData, $KeyData, $TextBoxData, $Variables, true);
  CloseTable();
  include("footer.php");
  exit;
} 
// Address format is valid or email not required, continue...

//Transform selection numbers into text
foreach($CharData as $key => $char)
{
	transClass($CharData[$key]['class']['text']);
	transProf($CharData[$key]['prof1']['text']);
	transProf($CharData[$key]['prof2']['text']);
}
transUser($UserData);

//start building the message string
//Escape special chars (prevents SQL injection, and SQL failures)
foreach($TextBoxData as $key => $value) //TextBoxes
	$TextBoxData[$key]['value'] = mysql_real_escape_string($value['value']);
foreach($KeyData as $key0 => $type) //Keys
{
	foreach($type['keys'] as $key1 => $gamekey)
			$KeyData[$key0]['keys'][$key1]['value'] = mysql_real_escape_string($gamekey['value']);
	$KeyData[$key0]['type']['value'] = mysql_real_escape_string($type['type']['value']);
}		
foreach($UserData as $key => $user) //User info
		$UserData[$key]['value'] = mysql_real_escape_string($user['value']);
foreach($CharData as $char => $chararray) //Character info
	foreach($chararray as $name => $vararray)
		if($name != "resistances")
			$CharData[$char][$name]['value'] = mysql_real_escape_string($vararray['value']);
		else
			foreach($vararray as $resistname => $resistvalue)
				$CharData[$char][$name][$resistname]['value'] = mysql_real_escape_string($resistvalue['value']);

/*
Array ( 
	[username] => Array ( [name] => username [value] => Your Name [show] => 1 [required] => 1 [text] => Bob Dole )
	[useremail] => Array ( [name] => useremail [value] => E-Mail [show] => 1 [required] => 1 [text] => bob@viagra.com )
	[userage] => Array ( [name] => userage [value] => Age [show] => 1 [required] => 0 [text] => )
	[usertime] => Array ( [name] => usertime [value] => Timezone [show] => 1 [required] => 0 [text] => )
	[userplay] => Array ( [name] => userplay [value] => Play Style [show] => 1 [required] => 0 [text] => )
	)
*/

if($UserData['username']['text'] != "")
	$msg = "{$UserData['username']['text']} has submitted an application <br />";
else
	$msg = "A visitor to the {$Variables['guildname']['value']} website has submitted a guild application <br />";

$first = 1;
foreach($UserData as $row)
	if($row['text'] != "")
	{
		if($first == 1)
		{
			showDivider("Personal Information", $msg);
			$first = 0;
		}
		$msg .= "- " . $row['value'] . ": <strong>" . $row['text'] . "</strong><br />";
	}
/*
showDivider("Personal Information", $msg);
if($UserData['username']['text'] != "")
	$msg .= "- Applicants Name: {$UserData['username']['text']} <br />";
if($UserData['useremail']['text'] != "")
	$msg .= "- Email Address: {$UserData['useremail']['text']} <br />";
if($UserData['usertime']['text'] != "")
	$msg .= "- Time Zone: {$UserData['usertime']['text']} <br />";
if($UserData['userage']['text'] != "")
	$msg .= "- Age: {$UserData['userage']['text']} <br />";
if($UserData['userplay']['text'] != "")
	$msg .= "- Play Style(1-casual, 10-hardcore): {$UserData['userplay']['text']} <br />";
*/

//showDivider("Main Character Information", $msg);
showCharInfo($CharData[0], $msg, "Main Character Information");
$first = 1;
foreach($CharData as $Char)
{
	if($first == 1)
	{
		$first = 0;
		continue;
	}
	if($Char['name']['text'] != "")
	{
//		if($first == 1)
//			showDivider("Alt Character(s) Information", $msg);
		showCharInfo($Char, $msg, "Alt Character(s) Information");
	}
}

$first = 2;
foreach($KeyData as $type)
{
	foreach($type['keys'] as $key)
	{
		if($key['text'] == "on")
		{
			if($first == 2)
			{
				showDivider("Keys/Attunements", $msg);
				$first = 1;
			}
			if($first == 1)
			{
				$msg .= "- <i>{$type['type']['value']}</i><br />";
				$first = 0;
			}
			$msg .= "    <strong>{$key['value']}</strong><br />";
		}
	}
	$msg .= "<br />";
	if($first == 0) $first = 1;
}
/*
//References
if($Variables['referral']['text'] != "")
{
	$msg .= "------------------------------------------------------------ <br />";
	$msg .= "-                Has the following references <br />";
	$msg .= "------------------------------------------------------------ <br />";
	$msg .= "- {$Variables['referral']['text']} <br />";
}
*/
$first = 1;
foreach($TextBoxData as $text)
{
	if($text['text'] != "")
	{
		if($first == 1)
		{
			showDivider("Has the following additional information to share", $msg);
			$first = 0;
		}
		$lineText = filter_text($text['value'], "nohtml");
		$msg .= "- In Response to: <br />";
		$msg .= "    <i>".filter_text($text['value'], "nohtml")."</i><br />";
		$msg .= " - They said : <br />";
		$msg .= "     <strong>".filter_text($text['text'], "nohtml")."</strong><br />";
		$msg .= "<br />";
	}
}

$postto = explode("_", $Variables['postto']['value']); 
$success0 = true;
$success1 = true;
if($postto[0] == "email" || count($postto) == 3)
{
	//add From: header
	$mailheaders = "From: {$Variables['guildname']['value']} Application Processing <{$Variables['recipient']['value']}>\r\n";
	//specify MIME version 1.0
	$mailheaders .= "MIME-Version: 1.0\r\n";
	//unique boundary
	$boundary = uniqid("HTMLAPP");
	//tell e-mail client this e-mail contains alternate versions
	$mailheaders .= "Content-Type: multipart/alternative; boundary = $boundary\r\n\r\n";
	//message to people with clients who don't
	//understand MIME
	$mailheaders .= "This is a MIME encoded message.\r\n\r\n";
	//plain text version of message
	$mailheaders .= "--$boundary\r\nContent-Type: text/plain; charset=ISO-8859-1\r\nContent-Transfer-Encoding: base64\r\n\r\n";
	$mailheaders .= chunk_split(base64_encode(filter_text(str_replace("<br />", "\n", stripslashes($msg)), "nohtml")));
	//HTML version of message
	$mailheaders .= "--$boundary\r\nContent-Type: text/html; charset=ISO-8859-1\r\nContent-Transfer-Encoding: base64\r\n\r\n";
	$mailheaders .= chunk_split(base64_encode(stripslashes($msg)));
	//send message
	$subject = "{$Variables['guildname']['value']} Application";
	//Send the mail
	if ($UserData['name']['text'] == $Variables['testname']['value'])
		$success0 = mail($Variables['testrecipient']['value'], $subject, "", $mailheaders);
	else 
		$success0 = mail($Variables['recipient']['value'], $subject, "", $mailheaders);
}
if($postto[0] == "forum")
{
	if($CharData[0]['name']['text'] != "" && $CharData[0]['class']['text'] != "")
		$subject = "Applicant: {$CharData[0]['name']['text']} - {$CharData[0]['class']['text']}";
	else
		$subject = "New Application to {$Variables['guildname']['value']}";
	$success1 = submit_post($postto[1], $subject, $msg, $Variables['postfrom']['value'], $Variables['postpoll']['show']);
}

//If we made it this far, everything should be ok to send.
if($success0 == true && $success1 == true)
	echo "<p><center><img src=\"../images/blocks/Recruitment/happy.gif\" alt=\"Thank You!\" border=\"0\"><br><br>
		 <strong>Thank you for submitting your request.</strong><br>
		 Your application has been submitted and we will be contacting you shortly.
		 </center></p>";
else
	echo "<p><center><img src=\"../images/blocks/Recruitment/stop.gif\" alt=\"Stop!\" border=\"0\"><br><br>
		 <strong>There was an error while submitting your application.</strong><br>
		 </center></p>";

CloseTable();
include("footer.php");

function fillCharArray($valueType, $arrayIndex, $value, &$array)
{
	switch(strtoupper($valueType[4]))
	{
		case 'R':
			$array[$arrayIndex]['resistances'][substr($valueType, 10, strlen($valueType) - 4)]['text'] = $value;
			break;
		default:
			$array[$arrayIndex][substr($valueType, 4, strlen($valueType) - 4)]['text'] = $value;
			break;
	}
}

function fillArray($valueType, $value, &$array)
{
	$array[$valueType]['text'] = $value;
}

function fillKeyArray($keyName, $value, &$array)
{
	$keys = 0;
	$index = 0;
	$keyNum = substr($keyName, 3, strlen($keyName) - 3);
	foreach($array as $type)
	{
		$keys += count($type['keys']);
		if($keys >= (int)$keyNum)
		{
			$keys = 0;
			foreach($type['keys'] as $key)
				if($key['name'] == $keyName)
					break;
				else
					$keys++;
			break;
		}
		else
			$index++;
	}
	$array[$index]['keys'][$keys]['text'] = $value;
}

function transUser(&$array)
{
	if($array['userage']['text'] != "")
	{
		switch($array['userage']['text'])
		{
			case 1:	$array['userage']['text'] = "Under 16";	break;
			case 2:	$array['userage']['text'] = "16-20";	break;
			case 3:	$array['userage']['text'] = "21-30";	break;
			case 4:	$array['userage']['text'] = "Over 30";	break;
			default: $array['userage']['text'] = "Unknown"; break;
		}
	}
	if($array['usertime']['text'] != "")
	{
		switch($array['usertime']['text'])
		{
			case 1: $array['usertime']['text'] = "Eastern"; break;
			case 2: $array['usertime']['text'] = "Central"; break;
			case 3: $array['usertime']['text'] = "Mountian"; break;
			case 4: $array['usertime']['text'] = "Pacific"; break;
			case 5: $array['usertime']['text'] = "Other"; break;
			default: $array['usertime']['text'] = "Unknown"; break;
		}
	}
}

//Prepare strings from selection boxes
function transClass(&$ClassNum)
{
	if($ClassNum != "")
	{
		switch($ClassNum)
		{
			case 1:	$ClassNum = "Warrior";	break;
			case 2:	$ClassNum = "Hunter";	break;
			case 3:	$ClassNum = "Rogue";	break;
			case 4:	$ClassNum = "Priest";	break;
			case 5:	$ClassNum = "Shaman";	break;
			case 6:	$ClassNum = "Druid";	break;
			case 7:	$ClassNum = "Mage";	break;
			case 8:	$ClassNum = "Warlock";	break;
			case 9:	$ClassNum = "Paladin";	break;
			case 10: $ClassNum = "Death Knight";  break;			
			default:	$ClassNum = "Unknown"; break;
		}
	}
}

function transProf(&$value)
{
	if($value != "")
	{
		switch($value)
		{
			case 1: $value = "Alchemy"; break;
			case 2: $value = "Blacksmithing"; break;
			case 3: $value = "Enchanting"; break;
			case 4: $value = "Engineering"; break;
			case 5: $value = "Herbalism"; break;
			case 6: $value = "Leatherworking"; break;
			case 7: $value = "Mining"; break;
			case 8: $value = "Skinning"; break;
			case 9: $value = "Tailoring"; break;
			case 10: $value = "Jewel Crafting"; break;
			case 11: $value = "Inscription"; break;			
		}
	}
}

function showDivider($title, &$text)
{
	$text .= "<hr><center><h3>$title</h3></center><hr>";
}

/*
function showDivider($title, &$text)
{
	$maxlength = 100;
	$length = (($maxlength - strlen($title)) / 2) - 1;
	$text .= "\n";
	for($i = 0; $i < $maxlength; $i++)
		$text .= "-";
	$text .="\n";
	$text .= "-";
	for($i = 0; $i < $length; $i++)
		$text .= " ";
	$text .= "$title \n";
	for($i = 0; $i < $maxlength; $i++)
		$text .= "-";
	$text .="\n";
}
*/

function showCharInfo($array, &$text, $title)
{
	$first = 1;
	foreach($array as $field)
		if($field['name'] != "" && $field['text'] != "")
			if($field['name'] != "gear")
			{
				if($first == 1)
				{
					showDivider($title, $text);
					$first = 0;
				}
				$text .= "- {$field['value']}: <strong>{$field['text']}</strong> <br />";
			}
	if($array['gear']['text'] != "")
	{
		if($first == 1)
		{
			showDivider($title, $text);
			$first = 0;
		}
		global $db;
		$sql = "select * from recruitment_config where type='geardata'";
		$result = $db->sql_query($sql);
		while($row = $db->sql_fetchrow($result))
			$gearData[$row['name']] = array('name' => $row['name'], 'value' => $row['value'], 'show' => $row['show'], 'required' => $row['required']);
		if($gearData['geartype']['value'] == "link")
			$text .= "- {$gearData['geartitle']['value']} link: <strong>{$array['gear']['text']}</strong><br />";
		else
			$text .= "- Has the following gear:<br /><strong>{$array['gear']['text']}</strong><br />";
	}
	if($array['build']['text'] != "")
	{
		if($first == 1)
		{
			showDivider($title, $text);
			$first = 0;
		}
		$text .= "- Has the following Talent build: <br />";
		$text .= "   Name: <strong>{$array['build']['text']}</strong><br />";
		$text .= "   Point Distribution: <strong>{$array['build0']['text']}</strong> / <strong>{$array['build1']['text']}</strong> / <strong>{$array['build2']['text']}</strong><br />";
	}
	$firstResist = 1;
	foreach($array['resistances'] as $resist)
		if($resist['text'] != "")
		{
			if($first == 1)
			{
				showDivider($title, $text);
				$first = 0;
			}
			if($firstResist == 1)
			{
				$text .= "- Has the following resistances: <br />";
				$firstResist = 0;
			}
			$text .= "    {$resist['value']}: <strong>{$resist['text']}</strong><br />";
		}
}

/***************************************************************************
 *                            functions_post.php
 *                            -------------------
 *   begin                : Saturday, Feb 13, 2001
 *   copyright            : (C) 2001 The phpBB Group
 *   email                : support@phpbb.com
 *
 *   $Id: functions_post.php,v 1.9.2.52 2006/05/06 13:38:55 grahamje Exp $
 * 
 *
 ***************************************************************************
*    Gutted and specialized by Nathan Burke to work with the application module
/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/
//
// Post a new topic/reply/poll or edit existing post/poll
//
function submit_post($forum_id, $post_subject, $post_message, $user_id = 1, $addPoll = 0, $pollLength = 7)
{
	global $prefix, $db;
	$current_time = time();
	$success = true;
	$sql = "INSERT INTO " . $prefix . "_bbtopics (topic_title, topic_poster, topic_time, forum_id, topic_status, topic_type, topic_vote) VALUES ('$post_subject', $user_id, $current_time, $forum_id, 0, 0, $addPoll)";
	if (!$db->sql_query($sql))
	{
		$sql = "INSERT INTO " . $prefix . "_bbtopics (topic_title, topic_poster, topic_time, forum_id, topic_status, topic_type, topic_vote) VALUES ('".mysql_real_escape_string($post_subject)."', $user_id, $current_time, $forum_id, 0, 0, $addPoll)";
		if (!$db->sql_query($sql))
		{
			echo "Error 1 while submitting application, your application has not been submitted<br />Please inform the webmaster.";
			$success = false;
		}
	}
	$topic_id = $db->sql_nextid();
	$sql = "INSERT INTO " . $prefix . "_bbposts (topic_id, forum_id, poster_id, post_time) VALUES ($topic_id, $forum_id, $user_id, $current_time)";
	if (!$db->sql_query($sql, BEGIN_TRANSACTION))
	{
		echo "Error 2 while submitting application, your application has not been submitted<br />Please inform the webmaster.";
		$success = false;
	}
	$post_id = $db->sql_nextid();
	$sql = "INSERT INTO " . $prefix . "_bbposts_text (post_id, post_subject, post_text) VALUES ($post_id, '$post_subject', '$post_message')";
	if (!$db->sql_query($sql))
	{
		$sql = "INSERT INTO " . $prefix . "_bbposts_text (post_id, post_subject, post_text) VALUES ($post_id, '".mysql_real_escape_string($post_subject)."', '".mysql_real_escape_string($post_message)."')";
		if (!$db->sql_query($sql))
		{
			echo "Error 3 while submitting application, your application has not been submitted<br />Please inform the webmaster.";
			$success = false;
		}
	}
	$sql = "UPDATE " . $prefix . "_bbtopics SET topic_last_post_id='$post_id', topic_first_post_id='$post_id' WHERE topic_id=$topic_id";
	if (!$db->sql_query($sql))
	{
		echo "Error 4 while submitting application, your application has not been submitted<br />Please inform the webmaster.";
		$success = false;
	}
	if ($addPoll == 1)
	{
		$poll_title = "Approve Application?";
		$sql = "INSERT INTO " . $prefix . "_bbvote_desc (topic_id, vote_text, vote_start, vote_length) VALUES ($topic_id, '$poll_title', $current_time, " . ($pollLength * 86400) . ")";
		if (!$db->sql_query($sql))
		{
			echo "Error 5 while submitting application, your application has not been submitted<br />Please inform the webmaster.";
			$success = false;
		}
		$poll_id = $db->sql_nextid();
		$poll_options = array(array(1, "Yes"), array(2, "No"), array(3, "Abstain"));
		foreach($poll_options as $option)
		{
			$sql = "INSERT INTO " . $prefix . "_bbvote_results (vote_id, vote_option_id, vote_option_text) VALUES ($poll_id, {$option[0]}, '{$option[1]}')";
			if (!$db->sql_query($sql))
			{
				echo "Error 6 while submitting application, your application has not been submitted<br />Please inform the webmaster.";
				$success = false;
			}
		}
	}
	$sql = "select forum_posts, forum_topics, forum_last_post_id from " . $prefix . "_bbforums where forum_id='$forum_id'";
	$result = $db->sql_query($sql);
	$forumdata = $db->sql_fetchrow($result);
	$forumdata['forum_posts'] = (int)$forumdata['forum_posts'] + 1;
	$forumdata['forum_topics'] = (int)$forumdata['forum_topics'] + 1;
	$forumdata['forum_last_post_id'] = $post_id;
	$sql = "UPDATE " . $prefix . "_bbforums SET forum_last_post_id='{$forumdata['forum_last_post_id']}', forum_posts='{$forumdata['forum_posts']}', forum_topics='{$forumdata['forum_topics']}' where forum_id='$forum_id'";
	$db->sql_query($sql);
	return $success;
}
?>