<?php

/*
==========================================
 PHP-NUKE: Recruitment Setting module - database table creation
 Version 2.1.0
==========================================
 Copyright (c) 2007
  by Nathan Burke
  based on work by:
    Arioch - http://www.black-blades.org

 This program is free software. You can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation
 
==========================================
*/


if (!eregi("modules.php", $_SERVER['PHP_SELF'])) {
    die ("You can't access this file directly...");
}

$module_name = basename(dirname(__FILE__));
include("config.php");
global $db;
include("header.php");
require_once ("mainfile.php");

	OpenTable();

	$create_table0 = "
					CREATE TABLE `recruitment_classes` (
					`name` varchar(32) NOT NULL,
					`status` varchar(32) NOT NULL,
					UNIQUE KEY `name` (`name`)
					) ENGINE=MyISAM DEFAULT CHARSET=latin1;";
	$populate_table0 = "INSERT INTO `recruitment_classes` (`name`, `status`) VALUES 
					('Status', 'Open'),
					('Death Knight', 'High'),
					('Druid', 'High'),
					('Hunter', 'High'),
					('Mage', 'High'),
					('Paladin', 'High'),
					('Priest', 'High'),
					('Rogue', 'High'),
					('Shaman', 'High'),
					('Warlock', 'High'),
					('Warrior', 'High');";
	$create_table1 = "
					CREATE TABLE `recruitment_config` (
					`name` varchar(32) NOT NULL,
					`value` text,
					`show` tinyint(1) NOT NULL,
					`required` tinyint(1) default NULL,
					`type` varchar(32) NOT NULL,
					UNIQUE KEY `name` (`name`)
					) ENGINE=MyISAM DEFAULT CHARSET=latin1;";
	$populate_table1 = "INSERT INTO `recruitment_config` (`name`, `value`, `show`, `required`, `type`) VALUES 
					('guildname', 'Your Guild', 0, 2, 'variable'),
					('numalts', '3', 0, 2, 'variable'),
					('guildrules', '', 0, 2, 'variable'),
					('rankstructure', '', 0, 2, 'variable'),
					('raidinginfo', '', 0, 2, 'variable'),
					('recipient', 'admin@yoursite.com', 0, 2, 'variable'),
					('testname', 'Test', 0, 2, 'variable'),
					('testrecipient', 'testaccount@yoursite.com', 0, 2, 'variable'),
					('referral', 'Contact(s) within your Guild - name of reference(s) if any:', 1, 0, 'variable'),
					('TextBox1', 'List any guilds (and their server) that you have been in or are currently in and reason(s) for leaving.<br>If you are a transfer, why have you chosen this server?', 1, 0, 'textbox'),
					('TextBox2', 'Please tell us a little bit about yourself.<br>What hours/days are you usually logged into WoW?<br>Why do you want to join Hybrid?', 1, 0, 'textbox'),
					('TextBox3', 'Please describe in detail your pre-BC raiding experience.', 1, 0, 'textbox'),
					('TextBox4', 'Are you currently on or have you completed ''The Trials of the Naaru''?<br>If have not completed this quest line, what step are you on?', 1, 0, 'textbox'),
					('footertext', '<div align=\"center\"><strong>All submissions are processed and evaluated.</strong><br /><br /><strong><font color=\"#ff0000\">Incomplete applications are generally rejected outright.</font></strong></div>', 1, 2, 'variable'),
					('headertext', '<div align=\"left\">Below you can find the current requirements:<br /> <ol> 	<li><strong>Must be level 70</strong></li> 	<li>Have your Karazhan attunement close to completed. If it is complete this will be a bonus</li> 	<li>You must be revered with Cenarion Expedition to be considered.  		<ul> 			<li>You must also be well on your way to revered with the HH, LC and Sha&#39;tar factions.</li> 		</ul> 	</li> 	<li>Have prior raid experience. We are looking for players with MC, BWL, AQ 20/40, Naxx (etc) experience. However this is not mandatory. A willingness to do the research and time required to understand the new content is required though.</li> 	<li>Meet the following raid requirements: 		<ul> 			<li>Be available to raid between the hours of 5:30st-10:00st Saturday - Thursday</li> 			<li>Have <a href=\"#\" onclick=\"window.open(\">KLHThreat Meter</a> installed and active</li> 			<li>Have installed and know how to use <a href=\"#\" onclick=\"window.open(\">Ventrilo</a></li> 			<ul> 				<li>It is not required for you to have a mic, but it is <em>strongly</em> recommended</li> 			</ul> 			<li>Be able to acquire mats, rep, and equipment outside of raid time. You must come prepared with your own consumables and reagants. If you intend to only show up for the raid, but put no effort into what goes into being raid prepared Hybrid is not the guild for you.</li> 		</ul> 	</li> 	<li>Have knowledge of your class. Currently we would like for classes to be spec&#39;d accordingly for raiding (Holy Priests, Resto Druids, Prot Warriors, etc.). If you are not spec&#39;d for raiding a willingness and openness to change is required.</li> 	<li><strong>Have a good attitude.</strong></li> </ol></div>', 1, 2, 'variable'),
					('KeyType1', 'Pre-BC Attunements/Keys', 1, 2, 'keytype'),
					('KeyType2', 'Heroic Mode Keys', 1, 2, 'keytype'),
					('KeyType3', 'BC Instance Keys', 1, 2, 'keytype'),
					('KeyType4', 'Endgame Keys', 1, 2, 'keytype'),
					('Key1', 'Onyxia', 1, 0, 'KeyType1'),
					('Key2', 'Molten Core', 1, 0, 'KeyType1'),
					('Key3', 'Blackwing Lair', 1, 0, 'KeyType1'),
					('Key4', 'Naxxramas', 1, 0, 'KeyType1'),
					('Key5', 'Auchenai', 1, 0, 'KeyType2'),
					('Key6', 'Warpforged', 1, 0, 'KeyType2'),
					('Key7', 'Reservoir', 1, 0, 'KeyType2'),
					('Key8', 'Flamewrought', 1, 0, 'KeyType2'),
					('Key9', 'Key of Time', 1, 0, 'KeyType2'),
					('Key10', 'Shattered Halls', 1, 0, 'KeyType3'),
					('Key11', 'Shadow Labyrinth', 1, 0, 'KeyType3'),
					('Key12', 'Arcatraz', 1, 0, 'KeyType3'),
					('Key13', 'Karazhan', 1, 0, 'KeyType4'),
					('Key14', 'Tempest Keep: The Eye', 1, 0, 'KeyType4'),
					('Key15', 'Serpentshrine Cavern', 1, 0, 'KeyType4'),
					('summarypage', '0', 1, 2, 'variable'),
					('summaryfooter', '	<div align=\"center\">This list is meant to give you an idea of the guilds current needs for the average high end (lvl. 60+) players.<br /> 	  Exceptions can and will be made for well geared - highly experienced players of classes not currently highly desired.</div> 	<br /><br /> 	<h3 align=\"center\"><font color=\"#ff0000\">So you want to join...</font></h3> 	<div align=\"center\">If you feel that you would fit into the guild and your main characters class is listed as highly desireable.<br /> 	  Or, if you feel that you have something special to offer the guild,<br />  	  please continue on to the application form by clicking on the link below.<br /> 	</div> 	<div align=\"center\">After reviewing your application, you will be contacted in-game or via email by a Senior Officer.<br /> 	  The officer will complete the application process by interviewing you and will then discuss your application<br /> 	  with other officers to determine if you will be recruited, denied or placed on a waiting list until a spot opens up.<br /> 	</div>', 1, 2, 'variable'),
					('postto', 'email', 0, 2, 'variable'),
					('postpoll', '0', 1, 2, 'variable'),
					('postfrom', '2', 1, 2, 'variable'),
					('username', 'Your Name', 1, 1, 'userinfo'),
					('useremail', 'E-Mail', 1, 1, 'userinfo'),
					('userage', 'Age', 1, 1, 'userinfo'),
					('usertime', 'Timezone', 1, 1, 'userinfo'),
					('userplay', 'Play Style', 1, 1, 'userinfo'),
					('mainname', 'Name', 1, 1, 'maindata'),
					('mainclass', 'Class', 1, 1, 'maindata'),
					('mainlevel', 'Level', 1, 1, 'maindata'),
					('mainprof1', 'Profession 1', 1, 1, 'maindata'),
					('mainprof2', 'Profession 2', 1, 1, 'maindata'),
					('mainaid', 'First Aid', 1, 1, 'maindata'),
					('maingear', 'Gear', 1, 1, 'maindata'),
					('mainbuild', 'Talent Build', 1, 1, 'maindata'),
					('mainresist', 'Provide information on your Resistences (Unbuffed)', 1, 1, 'maindata'),
					('altname', 'Name', 1, 0, 'altdata'),
					('altclass', 'Class', 1, 1, 'altdata'),
					('altlevel', 'Level', 1, 1, 'altdata'),
					('altprof1', 'Profession 1', 1, 1, 'altdata'),
					('altprof2', 'Profession 2', 1, 1, 'altdata'),
					('altaid', 'First Aid', 1, 1, 'altdata'),
					('altgear', 'Gear', 1, 1, 'altdata'),
					('altbuild', 'Talent Build', 1, 1, 'altdata'),
					('altresist', 'Provide information on your Resistences (Unbuffed)', 1, 1, 'altdata'),
					('geartype', 'link', 1, 1, 'geardata'),
					('gearlink', 'http://armory.worldofwarcraft.com/', 0, 0, 'geardata'),
					('supresseditor', '0', 0, 2, 'variable'),
					('geartitle', 'WoW Armory', 0, 0, 'geardata'),
					('fire', 'Fire', 1, 1, 'resistance'),
					('shadow', 'Shadow', 1, 1, 'resistance'),
					('nature', 'Nature', 1, 1, 'resistance'),
					('arcane', 'Arcane', 1, 1, 'resistance'),
					('frost', 'Frost', 1, 1, 'resistance');";
	$error = 0;
	$drop = "DROP TABLE `recruitment_classes` ,`recruitment_config`;";
	$db->sql_query($drop);
	echo "<table align=\"center\" width=\"300px\">";
	// Create table needed for recruitment information
	if($db->sql_query($create_table0))
		echo "<tr><td align=\"center\">Table successfully added: recruitment_classes</td></tr>";
	else
	{
		echo "<tr><td align=\"center\">Table could not be added: recruitment_classes</td></tr>";
		$error++;
	}
	// Populate recruitment table with initial data
	if($db->sql_query($populate_table0))
		echo "<tr><td align=\"center\">Table successfully populated</td></tr>";
	else
	{
		echo "<tr><td align=\"center\">Table could not be populated</td></tr>";
		$error++;
	}
	// Create table needed for application information
	if($db->sql_query($create_table1))
		echo "<tr><td align=\"center\">Table successfully added: recruitment_config</td></tr>";
	else 
	{
		echo "<tr><td align=\"center\">Table could not be added: recruitment_config</td></tr>";
		$error++;
	}
	// Populate application table with initial data
	if($db->sql_query($populate_table1))
		echo "<tr><td align=\"center\">Table successfully populated</td></tr>";
	else
	{
		echo "<tr><td align=\"center\">Table could not be populated</td></tr>";
		$error++;
	}
	if($error == 0)
		echo "<tr><td align=\"center\">Delete update_MYSQL_Recruitment.php and install_MYSQL_Recruitment.php now...</td></tr>";
	else
		echo "<tr><td align=\"center\">Install of database tables failed...</td></tr>";
	echo "</table>";

CloseTable();   
include("footer.php");

?>