<?php

/*
==========================================
 PHP-NUKE: Application module - variables creation
 Version 2.1.0
==========================================
 Copyright (c) 2007
  by Nathan Burke

 This program is free software. You can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation
 
==========================================
*/

function initialize(&$Variables, &$KeyData, &$TextBoxData)
{
	global $db;
	
	$sql = "select * from recruitment_config where type='variable'";
	$result = $db->sql_query($sql);
	while($row = $db->sql_fetchrow($result))
		$Variables[$row['name']] = array('value' => $row['value'], 'show' => $row['show'], 'required' => $row['required']);

	$sql = "select * from recruitment_config where type='textbox'";
	$result = $db->sql_query($sql);
	while($row = $db->sql_fetchrow($result))
		$TextBoxData[$row['name']] = array('name' => $row['name'], 'value' => $row['value'], 'show' => $row['show'], 'required' => $row['required']);

	$sql = "select * from recruitment_config where type='keytype'";
	$result = $db->sql_query($sql);
	$Keytypes = array();
	while($row = $db->sql_fetchrow($result))
		array_push($Keytypes, array('name' => $row['name'], 'value' => $row['value'], 'show' => $row['show'], 'required' => $row['required']));

	$KeyData = array();
	foreach($Keytypes as $type)
	{
		$sql = "select * from recruitment_config where type='{$type['name']}'";
		$result = $db->sql_query($sql);
		$Keys = array();
		while($row = $db->sql_fetchrow($result))
			array_push($Keys, array('name' => $row['name'], 'value' => $row['value'], 'show' => $row['show'], 'required' => $row['required']));
		array_push($KeyData, array('type' => $type, 'keys' => $Keys));
	}
}

function gimmeCharData(&$array, $numAlts = "")
{
	global $db;
	$sql0 = "select * from recruitment_config where type='maindata'";
	$sql1 = "select * from recruitment_config where type='altdata'";
	$sql2 = "select * from recruitment_config where type='resistance'";
	
	$result = $db->sql_query($sql2);
	while($row = $db->sql_fetchrow($result))
		$resistArray[($row['name'])] = array('name' => $row['name'], 'value' => $row['value'], 'show' => $row['show'], 'required' => $row['required']);

	if($array == "") $array = array();
	
	//Get main data and fill first index
	$tempArray = array();
	$result = $db->sql_query($sql0);
	while($row = $db->sql_fetchrow($result))
		$tempArray[substr($row['name'], 4, strlen($row['name']) - 4)] = array('name' => substr($row['name'], 4, strlen($row['name']) - 4), 'value' => $row['value'], 'show' => $row['show'], 'required' => $row['required']);
	$tempArray['resistances'] = $resistArray;
	array_push($array, $tempArray);

	//Get alt data
	$tempArray = array();
	$result = $db->sql_query($sql1);
	while($row = $db->sql_fetchrow($result))
		$tempArray[substr($row['name'], 3, strlen($row['name']) - 3)] = array('name' => substr($row['name'], 3, strlen($row['name']) - 3), 'value' => $row['value'], 'show' => $row['show'], 'required' => $row['required']);
	$tempArray['resistances'] = $resistArray;
	for($i = 0; $i < $numAlts; $i++)//Push the proper number of copies of the alt array onto the array
		array_push($array, $tempArray);
}

function gimmeData(&$array, $type)
{
	global $db;
	$sql = "select * from recruitment_config where type='$type'";
	$result = $db->sql_query($sql);
	while($row = $db->sql_fetchrow($result))
		$array[$row['name']] = array('name' => $row['name'], 'value' => $row['value'], 'show' => $row['show'], 'required' => $row['required']);
}
?>